题意:
给你一个奇数 n n n,让你构造一个 n ∗ n n*n n∗n的矩阵,矩阵的每个位置依次填上 [ 1 , n ∗ n ] 之 内 的 数 [1,n*n]之内的数 [1,n∗n]之内的数,满足每行、每列、以及主对角线的和都是奇数。
n ≤ 49 n\le49 n≤49
思路:
又是一个不能看范围的构造题。
由于每行、每列、主对角线和都需要是奇数,所以需要保证要加的数有奇数个奇数才可以,再进一步发现有 n ∗ n 2 + 1 \frac{n*n}{2}+1 2n∗n+1个奇数,我们考虑构造一个菱形,比如下面这个图
我们考虑将菱形内的所有数都填上奇数,其他位置都是偶数,这样构造出来的矩阵一定是合法的。
因为它保证了每行、每列、主对角线都有奇数个奇数。
貌似不需要费这么大劲,直接构造一个幻方即可。
// Problem: C. Magic Odd Square
// Contest: Codeforces - Educational Codeforces Round 16
// URL: https://codeforces.com/problemset/problem/710/C
// Memory Limit: 256 MB
// Time Limit: 1000 ms
//
// Powered by CP Editor (https://cpeditor.org)
//#pragma GCC optimize("Ofast,no-stack-protector,unroll-loops,fast-math")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4.1,sse4.2,avx,avx2,popcnt,tune=native")
//#pragma GCC optimize(2)
#include<cstdio>
#include<iostream>
#include<string>
#include<cstring>
#include<map>
#include<cmath>
#include<cctype>
#include<vector>
#include<set>
#include<queue>
#include<algorithm>
#include<sstream>
#include<ctime>
#include<cstdlib>
#include<random>
#include<cassert>
#define X first
#define Y second
#define L (u<<1)
#define R (u<<1|1)
#define pb push_back
#define mk make_pair
#define Mid ((tr[u].l+tr[u].r)>>1)
#define Len(u) (tr[u].r-tr[u].l+1)
#define random(a,b) ((a)+rand()%((b)-(a)+1))
#define db puts("---")
using namespace std;
//void rd_cre() { freopen("d://dp//data.txt","w",stdout); srand(time(NULL)); }
//void rd_ac() { freopen("d://dp//data.txt","r",stdin); freopen("d://dp//AC.txt","w",stdout); }
//void rd_wa() { freopen("d://dp//data.txt","r",stdin); freopen("d://dp//WA.txt","w",stdout); }
typedef long long LL;
typedef unsigned long long ULL;
typedef pair<int,int> PII;
const int N=1000010,mod=1e9+7,INF=0x3f3f3f3f;
const double eps=1e-6;
int n;
int a[100][100];
int main()
{
// ios::sync_with_stdio(false);
// cin.tie(0);
cin>>n;
int now=1;
for(int i=1;i<=n;i++) {
if(i<=n/2+1) {
for(int j=n/2+1-i+1,len=i*2-1;len;j++,len--)
a[i][j]=now,now+=2;
} else {
for(int j=i-n/2,len=(n-i)*2+1;len;j++,len--)
a[i][j]=now,now+=2;
}
}
now=2;
for(int i=1;i<=n;i++) for(int j=1;j<=n;j++) if(!a[i][j]) a[i][j]=now,now+=2;
for(int i=1;i<=n;i++) {
for(int j=1;j<=n;j++) {
printf("%d ",a[i][j]);
}
puts("");
}
return 0;
}
/*
*/